# All files / scripts/CDP/UI/listview GroupProfile.ts

17.76% Statements 27/152
2.67% Branches 2/75
9.38% Functions 3/32
17.36% Lines 25/144

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200
    201
    202
    203
    204
    205
    206
    207
    208
    209
    210
    211
    212
    213
    214
    215
    216
    217
    218
    219
    220
    221
    222
    223
    224
    225
    226
    227
    228
    229
    230
    231
    232
    233
    234
    235
    236
    237
    238
    239
    240
    241
    242
    243
    244
    245
    246
    247
    248
    249
    250
    251
    252
    253
    254
    255
    256
    257
    258
    259
    260
    261
    262
    263
    264
    265
    266
    267
    268
    269
    270
    271
    272
    273
    274
    275
    276
    277
    278
    279
    280
    281
    282
    283
    284
    285
    286
    287
    288
    289
    290
    291
    292
    293
    294
    295
    296
    297
    298
    299
    300
    301
    302
    303
    304
    305
    306
    307
    308
    309
    310
    311
    312
    313
    314
    315
    316
    317
    318
    319
    320
    321
    322
    323
    324
    325
    326
    327
    328
    329
    330
    331
    332
    333
    334
    335
    336
    337
    338
    339
    340
    341
    342
    343
    344
    345
    346
    347
    348
    349
    350
    351
    352
    353
    354
    355
    356
    357
    358
    359
    360
    361
    362
    363
    364
    365
    366
    367
    368
    369
    370
    371
    372
    373
    374
    375
    376
    377
    378
    379
    380
    381
    3821x

    1x

    1x

    1x

    1x

    1x

    1x

    1x

    1x

    1x

    1x

    1x

    1x

    1x

    1x

    1x

    1x

    1x

    1x

    1x

    1x

    1x

    1x

    1x

    1x

     ﻿namespace CDP.UI {

        const TAG = "[CDP.UI.GroupProfile] ";

        /**
         * @class GroupProfile
         * @brief ラインをグループ管理するプロファイルクラス
         *        本クラスでは直接 DOM を操作してはいけない
         */
        export class GroupProfile {
            private _parent: GroupProfile = null;       //!< 親 GroupProfile インスタンス
            private _children: GroupProfile[] = [];     //!< 子 GroupProfile インスタンス
            private _expanded: boolean = false;         //!< 開閉情報
            private _status: string = "unregistered";   //!< _owner への登録状態 [ unregistered | registered ]
            private _mapLines = {};                     //!< 自身が管轄する LineProfile を key とともに格納
            private static LAYOUT_KEY_DEFAULT = "-layout-default";

            /**
             * constructor
             *
             * @param _id    {String}             [in] GroupProfile の ID
             * @param _owner {ExpandableListView} [in] 管理者である ExpandableListView インスタンス
             */
            constructor(private _id: string, private _owner: BaseExpandableListView) {
            }

            ///////////////////////////////////////////////////////////////////////
            // public method

            /**
             * 本 GroupProfile が管理する List を作成して登録
             *
             * @param height      {Number}   [in] ラインの高さ
             * @param initializer {Function} [in] ListItemView 派生クラスのコンストラクタ
             * @param info        {Object}   [in] initializer に渡されるオプション引数
             * @param layoutKey   {String}   [in] layout 毎に使用する識別子 (オプショナル)
             * @return {GroupProfile} 本インスタンス
             */
            public addItem(
                height: number,
                initializer: new (options?: any) => BaseListItemView,
                info: any,
                layoutKey?: string
            ): GroupProfile {
                let line: LineProfile;
                const options = $.extend({}, { groupProfile: this }, info);

                if (null == layoutKey) {
                    layoutKey = GroupProfile.LAYOUT_KEY_DEFAULT;
                }
                if (null == this._mapLines[layoutKey]) {
                    this._mapLines[layoutKey] = [];
                }

                line = new LineProfile(this._owner.core, Math.floor(height), initializer, options);

                // _owner の管理下にあるときは速やかに追加
                if (("registered" === this._status) &&
                    (null == this._owner.layoutKey || layoutKey === this._owner.layoutKey)) {
                    this._owner._addLine(line, this.getLastLineIndex() + 1);
                    this._owner.update();
                }
                this._mapLines[layoutKey].push(line);
                return this;
            }

            /**
             * 子 Group を追加
             *
             * @param target {GroupProfile|GroupProfile[]} [in] GroupProfile インスタンス
             * @return {GroupProfile} 本インスタンス
             */
            public addChildren(target: GroupProfile): GroupProfile;
            public addChildren(target: GroupProfile[]): GroupProfile;
            public addChildren(target: any): GroupProfile {
                const children: GroupProfile[] = (target instanceof Array) ? target : [target];
                children.forEach((child) => {
                    child.setParent(this);
                });
                this._children = this._children.concat(children);
                return this;
            }

            /**
             * 親 GroupProfile を取得
             *
             * @return {GroupProfile} GroupProfile 親 インスタンス
             */
            public getParent(): GroupProfile {
                return this._parent;
            }

            /**
             * 子 GroupProfile を取得
             *
             * @return {GroupProfile[]} GroupProfile 子 インスタンス配列
             */
            public getChildren(): GroupProfile[] {
                return this._children;
            }

            /**
             * 子 Group を持っているか判定
             * layoutKey が指定されれば、layout の状態まで判定
             *
             * @param layoutKey {String} [in] layout 毎に使用する識別子 (オプショナル)
             * @return {Boolean} true: 有, false: 無
             */
            public hasChildren(layoutKey?: string): boolean {
                if (this._children.length <= 0) {
                    return false;
                } else if (null != layoutKey) {
                    return this._children[0].hasLayoutKeyOf(layoutKey);
                } else {
                    return true;
                }
            }

            /**
             * layout の状態を判定
             *
             * @param layoutKey {String} [in] layout 毎に使用する識別子
             * @return {Boolean} true: 有, false: 無
             */
            public hasLayoutKeyOf(layoutKey: string): boolean {
                if (null == layoutKey) {
                    layoutKey = GroupProfile.LAYOUT_KEY_DEFAULT;
                }
                return (null != this._mapLines[layoutKey]);
            }

            /**
             * グループ展開
             */
            public expand(): void {
                let lines: LineProfile[] = [];
                if (this._lines.length < 0) {
                    console.warn(TAG + "this group has no lines.");
                } else if (!this.hasChildren()) {
                    console.warn(TAG + "this group has no children.");
                } else if (!this.isExpanded()) {
                    lines = this.queryOperationTarget("registered");
                    this._expanded = true;
                    if (0 < lines.length) {
                        this._owner.statusScope("expanding", () => {
                            // 自身を更新
                            this._lines.forEach((line: LineProfile) => {
                                line.refresh();
                            });
                            // 配下を更新
                            this._owner._addLine(lines, this.getLastLineIndex() + 1);
                            this._owner.update();
                        });
                    }
                }
            }

            /**
             * グループ収束
             *
             * @param delay {Number} [in] 要素削除に費やす遅延時間. 既定: animationDuration 値
             */
            public collapse(delay?: number): void {
                let lines: LineProfile[] = [];
                if (!this.hasChildren()) {
                    console.warn(TAG + "this group has no children.");
                } else if (this.isExpanded()) {
                    lines = this.queryOperationTarget("unregistered");
                    this._expanded = false;
                    if (0 < lines.length) {
                        delay = (null != delay) ? delay : this._owner.core.getListViewOptions().animationDuration;
                        this._owner.statusScope("collapsing", () => {
                            // 自身を更新
                            this._lines.forEach((line: LineProfile) => {
                                line.refresh();
                            });
                            // 配下を更新
                            this._owner.removeItem(lines[0].index, lines.length, delay);
                            this._owner.update();
                        });
                    }
                }
            }

            /**
             * 自身をリストの可視領域に表示
             *
             * @param options {EnsureVisibleOptions} [in] オプション
             */
            ensureVisible(options?: EnsureVisibleOptions): void {
                if (0 < this._lines.length) {
                    this._owner.ensureVisible(this._lines[0].index, options);
                } else if (null != options.callback) {
                    options.callback();
                }
            }

            /**
             * 開閉のトグル
             *
             * @param delay {Number} [in] collapse の要素削除に費やす遅延時間. 既定: animationDuration 値
             */
            public toggle(delay?: number): void {
                if (this._expanded) {
                    this.collapse(delay);
                } else {
                    this.expand();
                }
            }

            /**
             * 展開状態を判定
             *
             * @return {Boolean} true: 展開, false:収束
             */
            public isExpanded(): boolean {
                return this._expanded;
            }

            /**
             * list view へ登録
             * Top Group のみ登録可能
             *
             * @param insertTo {Number} 挿入位置を index で指定
             * @return {GroupProfile} 本インスタンス
             */
            public register(insertTo: number): GroupProfile {
                if (this._parent) {
                    console.error(TAG + "logic error: 'register' method is acceptable only top group.");
                } else {
                    this._owner._addLine(this.preprocess("registered"), insertTo);
                }
                return this;
            }

            /**
             * list view へ復元
             * Top Group のみ登録可能
             *
             * @return {GroupProfile} 本インスタンス
             */
            public restore(): GroupProfile {
                let lines: LineProfile[] = [];
                if (this._parent) {
                    console.error(TAG + "logic error: 'restore' method is acceptable only top group.");
                } else if (this._lines) {
                    if (this._expanded) {
                        lines = this._lines.concat(this.queryOperationTarget("active"));
                    } else {
                        lines = this._lines;
                    }
                    this._owner._addLine(lines);
                }
                return this;
            }

            /**
             * 配下の最後の line index を取得
             *
             * @param withActiveChildren {Boolean} [in] 登録済みの子 GroupProfile を含めて検索する場合は true を指定
             * @return {Number} index. エラーの場合は null.
             */
            public getLastLineIndex(withActiveChildren: boolean = false): number {
                const lines: LineProfile[] = (() => {
                    let _lines: LineProfile[];
                    if (withActiveChildren) {
                        _lines = this.queryOperationTarget("active");
                    }
                    if (null == lines || lines.length <= 0) {
                        _lines = this._lines;
                    }
                    return _lines;
                })();

                if (lines.length <= 0) {
                    console.error(TAG + "logic error: this group is stil not registered.");
                    return null;
                } else {
                    return lines[lines.length - 1].index;
                }
            }

            /**
             * ID を取得
             *
             * @return {String} 割り振られた ID
             */
            get id(): string {
                return this._id;
            }

            /**
             * ステータスを取得
             *
             * @return {String} ステータス文字列
             */
            get status(): string {
                return this._status;
            }

            ///////////////////////////////////////////////////////////////////////
            // private method

            /* tslint:disable:no-unused-variable */

            /**
             * 親 Group 指定
             *
             * @param parent {GroupProfile} [in] 親 GroupProfile インスタンス
             */
            private setParent(parent: GroupProfile): void {
                this._parent = parent;
            }

            /* tslint:enable:no-unused-variable */

            /**
             * register / unregister の前処理
             *
             * @param newStatus {String} [in] 新ステータス文字列
             * @return {LineProfile[]} 更新すべき LineProfile の配列
             */
            private preprocess(newStatus: string): LineProfile[] {
                let lines: LineProfile[] = [];
                if (newStatus !== this._status && null != this._lines) {
                    lines = this._lines;
                }
                this._status = newStatus;
                return lines;
            }

            /**
             * 操作対象の LineProfile 配列を取得
             *
             * @param newStatus {String} [in] 新ステータス文字列
             * @return {LineProfile[]} 操作対象の LineProfile の配列
             */
            private queryOperationTarget(operation: string): LineProfile[] {
                const findTargets = (group: GroupProfile): LineProfile[] => {
                    let lines: LineProfile[] = [];
                    group._children.forEach((child: GroupProfile) => {
                        switch (operation) {
                            case "registered":
                                lines = lines.concat(child.preprocess(operation));
                                break;
                            case "unregistered":
                                lines = lines.concat(child.preprocess(operation));
                                break;
                            case "active":
                                if (null != child._lines) {
                                    lines = lines.concat(child._lines);
                                }
                                break;
                            default:
                                console.warn(TAG + "unknown operation: " + operation);
                                return;
                        }
                        if (child.isExpanded()) {
                            lines = lines.concat(findTargets(child));
                        }
                    });
                    return lines;
                };
                return findTargets(this);
            }

            /**
             * 自身の管理するアクティブな LineProfie を取得
             *
             * @return {LineProfile[]} LineProfie 配列
             */
            private get _lines(): LineProfile[] {
                const key = this._owner.layoutKey;
                if (null != key) {
                    return this._mapLines[key];
                } else {
                    return this._mapLines[GroupProfile.LAYOUT_KEY_DEFAULT];
                }
            }
        }
    }